
# Базовый синтаксис декоратора в python

def my_decorator(func):

    def wrapper_func():
        # Делаем что-то до вызова функции
        func()
        # Делаем что-то после вызова функции

    return wrapper_func


def decorator(func):
    def wrapper():
        print('Start decorator')
        func()
        print('Finish decorator')
    return wrapper


@decorator
def my_func():
    print('This is my mega function!')

def main():
    my_func()


if __name__ == '__main__':
    main()